#include "DS1302.h"
 
DS1302::DS1302()
{
}

void DS1302::Write_Byte(uint8_t d)
{
	uint8_t i;
	DS1302_IO_OUT;
	_delay_us(10);
	for(i=0;i<8;i++)
	{
  	DS1302_CLK_L;
  	_delay_us(10);
  	if((d&0x01)==0)
  	{
   		DS1302_IO_L;
  	}
  	else
  	{
   		DS1302_IO_H;
  	}
  	_delay_us(10);
  	DS1302_CLK_H;
  	_delay_us(10);
  	d=d>>1;
	}
}

uint8_t DS1302::Read_Byte(void)
{
	uint8_t i;
	uint8_t temp;
	temp=0;
	DS1302_IO_H;
	DS1302_IO_IN;
	_delay_us(10);
	for(i=0;i<8;i++)
	{
		temp=temp>>1;
  	DS1302_CLK_H;
  	_delay_us(10);
  	DS1302_CLK_L;
  	_delay_us(10);
  	if(DS1302_IO_INPORT&(1<<RTC_IO_PIN))
  	{
   		temp=temp+0x80;
  	}
	}
	return(temp);
}

void DS1302::Write1302(uint8_t ucAddr, uint8_t ucDa)
{
	DS1302_CS_OUT;
	_delay_us(10);
	DS1302_CLK_OUT;
	_delay_us(10);
	DS1302_CS_L;
	_delay_us(10);
  DS1302_CLK_L;
	_delay_us(10);
  DS1302_CS_H;
	_delay_us(10);
  Write_Byte(ucAddr);       // address
  Write_Byte(ucDa);         // data
	DS1302_CS_L;
}

uint8_t DS1302::Read1302(uint8_t ucAddr)
{
	uint8_t volatile ucData;
  ucData = 0;
	DS1302_CS_OUT;
	_delay_us(10);
	DS1302_CLK_OUT;
	_delay_us(10);
  DS1302_CS_L;
	_delay_us(10);
  DS1302_CLK_L;
	_delay_us(10);
  DS1302_CS_H;
	_delay_us(10);
  Write_Byte(ucAddr);     
  ucData = Read_Byte();
	DS1302_CS_L;
  return ucData;
}



void DS1302::settime(const RTC *rtc)
{
  uint8_t i;
  uint8_t addr = 0x80;       //start from second register
  uint8_t buf[7];
	
	buf[0] = INTtoBCD(rtc->sec);
	buf[1] = INTtoBCD(rtc->min);
	buf[2] = INTtoBCD(rtc->hour);
	buf[3] = INTtoBCD(rtc->mday);
	buf[4] = INTtoBCD(rtc->month);
    buf[5] = INTtoBCD(rtc->wday);
	buf[6] = INTtoBCD(rtc->year - 2000);
	
	
	Write1302(C_WP,0x00);               //write enable

    for(i=0;i<7;i++)
    { 
        Write1302(addr,buf[i]); // second, minute, hour, day, month, week, year
        addr+=2;
    }
    Write1302(C_WP,0x80);              //disable write
}

void DS1302::gettime(RTC* rtc)
{
	uint8_t i;
	uint8_t addr = 0x81;
	uint8_t buf[7];


	
	for(i=0; i<7; i++){
		buf[i] = Read1302(addr);
		addr+=2;
	}
	
	rtc->sec = BCDtoINT(buf[0]);
	rtc->min = BCDtoINT(buf[1]);
	rtc->hour = BCDtoINT(buf[2]);
	rtc->mday = BCDtoINT(buf[3]);
	rtc->month = BCDtoINT(buf[4]);
	rtc->wday = BCDtoINT(buf[5]);
	rtc->year = BCDtoINT(buf[6])+2000;
	
	DS1302_CLK_L;

}


